package praktikum02;

//Zahlenfilter
public class Zahlenfilter02 {

    private int start;

    private int end;

    public Zahlenfilter02(int s, int e) {
        start = s;
        end = e;
    }

    public static void main(String[] args) {
        // Standardendwert ist 200, falls keine Argumente übergeben werden
        int end = 200;

        // Überprüfen, ob ein Programmargument übergeben wurde
        if (args.length > 0) {
            try {
                // Versuchen, das Argument in eine Zahl umzuwandeln
                end = Integer.parseInt(args[0]);
            } catch (NumberFormatException e) {
                // Fehlermeldung, wenn das Argument keine gültige Zahl ist
                System.out.println("Fehler: Bitte eine gültige Zahl als Programmargument eingeben.");
            }
        }

        Zahlenfilter02 zf = new Zahlenfilter02(1, end);
        zf.printNumbers();
    }

   private void printNumbers() {
       for (int i = 1; i <= end; i++) {
           if (filter(i))
               System.out.print(i + " ");
       }
   }

    public static boolean filter(int number) {
        return !(checkDivByFive(number) || checkEndsWithNine(number) || checkSumDivByThree(number));
    }

    public static boolean checkDivByFive(int number) {
        // Wenn durch 5 Teilbar
        return (number % 5 == 0);
    }

    public static boolean checkEndsWithNine(int number) {
        // Wenn Zahl auf 9 endet
        return (number % 10 == 9);
    }

    public static boolean checkSumDivByThree(int number) {
        int vorgaenger = number - 1;
        int summe = number + vorgaenger;


        // Überprüfen, ob die Summe durch 3 teilbar ist
        return (summe % 3 == 0);
    }
}